#include <vector>
#include <filesystem>
#include <Windows.h>
#include <sigscanner.h>
#include <MinHook.h>

LPVOID addrCreatePlaybackThread = NULL;
LPVOID addrPlaySong = NULL;
LPVOID playSongOriginal = NULL;
int debug = 0;

std::vector<std::pair<std::string, bool>> ingameSongs = {
		{"ingame-01-generic.wav", true},
		{"ingame-02-cavern.wav", true},
		{"ingame-03-jungle.wav", true},
		{"ingame-04-battlezone.wav", true},
		{"ingame-05-forest.wav", true},
		{"ingame-06-weird-alien-plan.wav", true},
		{"ingame-07-outerspace.wav", true},
		{"ingame-08-desert.wav", true},
		{"ingame-09-hell.wav", true},
		{"ingame-10-mech-workshop.wav", true},
		{"ingame-11-rain&surf.wav", true}
};

std::vector<std::pair<std::string, bool>> suddendeathSongs = {
		{"suddendeath2-loop.wav", true},
		{"suddendeath1-loop.wav", true}
};

void scanDirs(std::string base, std::string dir, std::vector<std::pair<std::string, bool>> & collection) {
	namespace fs = std::filesystem;
	std::string directory = base + "/" + dir;
	fs::create_directories(directory);
	for(auto& p: fs::directory_iterator(directory)) {
		auto abspath = fs::absolute(p.path());
		std::string filename = abspath.string();
		collection.push_back({filename, false});
	}

	if(debug) {
		std::string out = "List of audio tracks for \"" + dir + "\" mode:";
		for (auto & pair : collection) {
			out += "\n\t" + pair.first + " " + (pair.second ? "(original)" : "(new)");
		}
		MessageBoxA(0, out.c_str(), "wkNewWave", MB_ICONINFORMATION);
	}
}

int playSongHooked(int songnumber_a1, int a2, int a3) {
	const char *song = 0;
	char songPath[MAX_PATH]{0};
	bool isOriginal = true;
	if(songnumber_a1 >= 1 && songnumber_a1 <= 11) {
		if (ingameSongs.empty()) return 0;
		auto & pair = ingameSongs[rand() % ingameSongs.size()];
		song = pair.first.c_str(); isOriginal = pair.second;
	} else if (songnumber_a1 == 12 || songnumber_a1 == 13) {
		if (suddendeathSongs.empty()) return 0;
		auto & pair = suddendeathSongs[rand() % suddendeathSongs.size()];
		song = pair.first.c_str(); isOriginal = pair.second;
	} else {
		return 0;
	}

	if (isOriginal) {
		sprintf_s(songPath, "%s/%s", (char*)(a2+132), song);
	} else {
		strcpy_s(songPath, song);
	}

	if(debug) {
		std::string msg = "Now playing track:\n";
		msg += songPath;
		msg += (isOriginal ? " (original)" : " (new)");
		MessageBoxA(0, msg.c_str(), "wkNewWave", MB_ICONINFORMATION);
	}

	//another nasty function call
	// createPlaybackThread_545390((HMMIO)(a2 + 400), *(DWORD *)(a2 + 396), &Dest, (a3 != 0) | 0x24);
	// DWORD __userpurge createPlaybackThread_545390@<eax>(HMMIO a1@<esi>, int a2, char *Path, int a4)
	int arg1 = a2+400;
	int arg2 = *(DWORD *)(a2 + 396);
	int arg3 = (int)songPath;
	int arg4 = (int)(a3 != 0) | 0x24;
	int playback_ret;
	_asm {
		mov esi, arg1
		push arg4
		push arg3
		push arg2;
		call addrCreatePlaybackThread
		mov playback_ret, eax
	};

	// shameless copy&paste from hexrays
	if ( *(DWORD *)(a2 + 812) ) {
		(*(void (__stdcall **)(DWORD, int))(**(DWORD **)(a2 + 812) + 36))(*(DWORD *)(a2 + 812), a2 + 808);
		return *(DWORD *)(a2 + 808) & 1;
	} else return 0;
}

#pragma optimize( "", off )
int a1, a2;
void __stdcall playSongHooked_wrapper(int a3) {
	//int __userpurge playsongnumber_sub_55BB70@<eax>(int songnumber_a1@<eax>, int a2@<edi>, int a3)
	// we are in a middle of a really nasty subroutine call and we cannot manipulate stack frame here
	// let's grab function arguments and create a new stack frame
	_asm {
		mov a1, eax
		mov a2, edi
	};
	playSongHooked(a1, a2, a3);
}
#pragma optimize( "", on )

int scanMemoryAndHook() {
	//get process name - https://stackoverflow.com/questions/45474424/how-to-get-the-name-of-the-process-your-dll-was-injected-into
	HMODULE hExe = GetModuleHandle(NULL);
	char fullPath[MAX_PATH]{0};
	char fname[MAX_PATH] = {0};
	char ext[MAX_PATH] = {0};
	char procName[MAX_PATH] = {0};
	GetModuleFileName(hExe, fullPath, MAX_PATH);
	_splitpath(fullPath, 0, 0, fname, ext);
	strcpy(procName, fname);
	strcat(procName, ext);

	// scan memory for signature - https://github.com/Zer0Mem0ry/SignatureScanner/blob/master/SignatureScanner/sig.cpp
	SignatureScanner SigScanner;
	if (SigScanner.GetProcess(procName)) {
		module mod = SigScanner.GetModule(procName);
		addrPlaySong = (LPVOID*) SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x83\xC0\xFF\x81\xEC\x00\x01\x00\x00", "xxxxxxxxx");
		addrCreatePlaybackThread = (LPVOID*) SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x81\xEC\x0C\x01\x00\x00\x83\xBE\x7C\x01\x00\x00\x00", "xxxxxxxxxxxxx");

		if (!addrPlaySong || !addrCreatePlaybackThread) {
			MessageBoxA(0, "Failed to find subroutine signature - your WA.exe is incompatible with this module.", "wkNewWave", MB_ICONERROR);
			return -2;
		}

		if (MH_Initialize() != MH_OK) {
			MessageBoxA(0, "Failed to initialize MinHook.", "wkNewWave", MB_ICONERROR);
			return -3;
		}

		if (MH_CreateHook(addrPlaySong, &playSongHooked_wrapper, &playSongOriginal) != MH_OK) {
			MessageBoxA(0, "Failed to create subroutine hook.", "wkNewWave", MB_ICONERROR);
			return -4;
		}

		if (MH_EnableHook(addrPlaySong) != MH_OK) {
			MessageBoxA(0, "Failed to enable subroutine hook.", "wkNewWave", MB_ICONERROR);
			return -5;
		}

		return 0;
	} else {
		MessageBoxA(0, "Failed to initialize signature scanner", "wkNewWave", MB_ICONERROR);
		return -1;
	}
}


BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved) {
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
		{
			scanMemoryAndHook();
			int playOnlyNewSongs = GetPrivateProfileIntA("config", "playOnlyNewSongs", 0, "./wkNewWave.ini");
			debug = GetPrivateProfileIntA("config", "debug", 0, "./wkNewWave.ini");
			if(playOnlyNewSongs) {
				ingameSongs.clear();
				suddendeathSongs.clear();
			}
			scanDirs("DATA/Streams", "ingame", ingameSongs);
			scanDirs("DATA/Streams", "suddendeath", suddendeathSongs);
			srand(time(0));
		}
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
	return TRUE;
}

